

#### main function for estimating parameters of CUSCUB, CUSB, SCUB and SSB models #######################

MS2.Cub<-function(data,f,func,start=NULL,method="NM",print.level=0,
finalHessian=TRUE,tol=1e-06,iterlim=1000,EMiter=300,NMiter=0,numeric=FALSE,fixed=NULL,WMAT=NULL,n=NULL,
compare=FALSE,epseps=1e-04,CUSCUB=FALSE,CUSB=FALSE,startW=0,nat.par=FALSE){
if(!is.element(method,c("NM","BFGS","BHHH","BFGSR"))) {print("method not available I'll use NM")
                                               method="NM"}
#CUSB<-FALSE
if(method=="NM"){NMiter=0}
                                               
bind<-epseps
nvar<-length(f)
v<-rep(0,nvar)
p<-v
X<-list()
for(i in 1:nvar){
v[i]<-all.vars(f[[i]])[1]
X[[i]]<-model.matrix(f[[i]],data)
XX<-X[[i]]
p[i]<-dim(X[[i]])[2]
}


#v_u<-rep(0,nvar)
p_U<-rep(0,nvar)
X_U<-list()
for(i in 1:nvar){
#v_u[i]<-all.vars(func[[i]])[1]
X_U[[i]]<-model.matrix(func[[i]],data)
XX_U<-X_U[[i]]
p_U[i]<-dim(X_U[[i]])[2]
}


no<-setdiff(names(data),v)
data<-data[,c(v,no)]

names1<-colnames(X[[1]])
names1_U<-colnames(X_U[[1]])
n<-max(data[,1])
if(is.null(start)){


#edit(data.frame(resp,data))
iniz<-CUBpq(data[,1],X_U[[1]],X[[1]],numiter=EMiter,toler=tol)
b_iniz<-iniz$gama
a_iniz<-iniz$pai}

if(nvar==1){
  

if(is.null(start)){

start<-c( b_iniz,a_iniz )}


names<-c(names1,names1_U)
names(start)<-names}
if(nvar>1){

if(is.null(WMAT)) WMAT<-diag(1,nvar*(nvar-1)/2)

##########inizialization#############


for( i in 2:nvar){
#Xmat<-X[[i]]n
if(is.null(start)){

inizz<-CUBpq(data[,i],X_U[[i]],X[[i]],numiter=EMiter,toler=tol)
b_iniz<-c(b_iniz,inizz$gama)
a_iniz<-c(a_iniz,inizz$pai)}
n<-c(n,max(data[,i]))
names1<-c(names1,colnames(X[[i]]))
names1_U<-c(names1_U,colnames(X_U[[i]]))
}


XX<-do.call(cbind,X)
XX_U<-do.call(cbind,X_U)


if(dim(WMAT)[2]==nvar*(nvar-1)/2){
nomega<-paste("omega",vech(as.matrix(matrix(paste(rep(1:nvar,each=nvar),rep(1:nvar,times=nvar),sep="."),nvar,nvar)[-1,-nvar])),sep="")
}
else if(nvar >1) nomega<-paste("beta.omega",1:dim(WMAT)[2],sep="")

names1<-c(names1,names1_U,nomega,"phi")
#print(start)
#print(names1)
if(is.null(start)){start<-c(b_iniz,a_iniz,rep(startW,dim(WMAT)[2]),0 )
#if(CUSCUB){start<-c(b_iniz,a_iniz,rep(startW,dim(WMAT)[2]),99 )
#fixed<-sort(c(fixed,length(start)))} 
}
names(start)<-names1
}
if(CUSB){start[(sum(p)+1):(sum(p)+nvar)]<-99
fixed<-sort(c(fixed,(sum(p)+1):(sum(p)+nvar)))}
if(CUSCUB){start[length(start)]<-99
fixed<-sort(c(fixed,length(start)))} 
if(print.level>0){
print("fixed parameters")
print(names1[fixed])
print("number of categories for each variable")
print(n)
print("number of configurations")
print(prod(n))
print("staring values")
print(start)}

################## auxiliar functions for MS.Cub environment ######################################

############### function for CUB -- one observation #############
SCUBMexp<-function(n,x,csi,pi,W,fi){
#print(W)
M<-length(n)
find<-(pi[M]*choose(n[M]-1,x[M]-1)*(1-csi[M])^(x[M]-1)*csi[M]^(n[M]-x[M])+(1-pi[M])/n[M])
cas<-prod(n)
SAR=1


if(M>1){
for(i in 1:(M-1)){
pi1=pi[i]
csi1<-csi[i]
x1<-x[i]
n1<-n[i]

find<-find*(pi1*choose(n1-1,x1-1)*(1-csi1)^(x1-1)*csi1^(n1-x1)+(1-pi1)/n1)
for( j in (i+1):M) {

pi2=pi[j]
csi2<-csi[j]
n2<-n[j]
x2<-x[j]
w<-W[i,j]

f2<- w*
( exp(-x1) -pi1*exp(-1)*(   (1-csi1)* exp(-1)+csi1 )^(n1-1)-(1-pi1)/n1* (exp(-1)-exp(-n1-1))/(1-exp(-1)   ))*
( exp(-x2)-pi2*exp(-1)*(   (1-csi2)* exp(-1)+csi2 )^(n2-1)-(1-pi2)/n2* (exp(-1)-exp(-n2-1))/(1-exp(-1)   ))

SAR<-SAR+f2
}
}
}
#print(SAR)

cub<-find*SAR

find<-fi*find+(1-fi)/cas
f<-cub*fi+(1-fi)/cas
#print(f[1:10])
#cbind(find,f,cub)
}


######################loglik for one observation ############################################

Lmscub<-function(theta){


theta.pi<-theta[(sum(p)+1):(sum(p)+sum(p_U))]
theta.csi<-theta[1:sum(p)]


####pi[1]<-exp(theta.pi[1])/(1+exp(theta.pi[1]))
fi<-1
if(nvar>1){
np<-length(theta)
theta.fi<-theta[np]

fi<-exp(theta.fi)/(1+exp(theta.fi))

w<-theta[-( 1:(sum(p)+sum(p_U)) )]
w<-w[-length(w)]
w<-WMAT%*%w
W<-triang(w,(nvar-1))
#W<-rbind( cbind(W,rep(0,(nvar-1))),rep(0,nvar))
W<-cbind(rep(0,nvar), rbind(W,rep(0,(nvar-1))))

#####for(i in 2:nvar){
######pi<-c(pi, exp(theta.pi[i])/(1+exp(theta.pi[i])))}

}

CSI<-matrix(0,dim(data)[1],nvar)
CSI_U<-matrix(0,dim(data)[1],nvar)
pstart<-0
pstart_U<-0
for(i in 1:nvar){
e<-X[[i]]%*%theta.csi[(pstart+1):(pstart+p[i])]
e_U<-X_U[[i]]%*%theta.pi[(pstart_U+1):(pstart_U+p_U[i])]
#CSI[,i]<-exp(e)/(1+exp(e))
CSI[,i]<-pmin(1-bind,pmax(bind,exp(e)/(1+exp(e))))
CSI_U[,i]<-pmin(1-bind,pmax(bind,exp(e_U)/(1+exp(e_U))))
pstart_U<-pstart_U+p_U[i]
pstart<-pstart+p[i]}
#print(CSI)
#print(CSI_U)
LMmy<-function(data){
#data<-as.data.frame(t(data))

x<-data[1:nvar]
csi<-data[(nvar+1):(nvar+nvar)]
csi_U<-data[(2*nvar+1):(3*nvar)]
p<-SCUBMexp(n,x,csi,csi_U,W,fi)
p<-max(p,bind)
#loglik<-log(p[2])
loglik<-log(p)

}
l<-apply(X=cbind(data[,1:nvar],CSI,CSI_U),MARGIN=1,FUN=LMmy)

}
###########################################################################
##################### functions for derivatives for one observation ###################################
SCUB_so<-function(n,csi,ppi,W,dx,fi){
M<-length(n)
#x<-1:n[M]
find<-1
L<-list()
D<-list()
PHI<-list()
CONT<-list()
PSHIFT<-list()
PCUB<-list()
SAR<-1
if(M>1){
matrix(1,prod(n))
cont<-0
for(i in 1:(M-1)){
pi1=ppi[i]
csi1<-csi[i]
#x1<-1:n[i]
x1<-dx[i]
n1<-n[i]
bs<-choose(n1-1,x1-1)*(1-csi1)^(x1-1)*csi1^(n1-x1)
ps<-(pi1*bs+(1-pi1)/n1)
phi_i<-( exp(-x1) -pi1*exp(-1)*(   (1-csi1)* exp(-1)+csi1 )^(n1-1)-(1-pi1)/n1* (exp(-1)-exp(-n1-1))/(1-exp(-1)   ))
find<-find%x%ps
PSHIFT[[i]]<-bs
PCUB[[i]]<-ps
for( j in (i+1):M) {
cont<-cont+1
pi2=ppi[j]
csi2<-csi[j]
n2<-n[j]
#x2<-1:n[j]
x2<-dx[j]
w<-W[i,j]
phi_j<-( exp(-x2)-pi2*exp(-1)*(   (1-csi2)* exp(-1)+csi2 )^(n2-1)-(1-pi2)/n2* (exp(-1)-exp(-n2-1))/(1-exp(-1)   ))
phi_ij<-1%x%phi_i%x%1%x%phi_j%x%1
f2<- w*phi_ij
SAR<-SAR+f2
#####mod#####
D_ij<-1%x%phi_i%x%1%x%diag(1,n2)[x2,]%x%1
L_ij<-1%x%diag(1,n1)[x1,]%x%1%x%phi_j%x%1
D[[cont]]<-D_ij
L[[cont]]<-L_ij
CONT[[cont]]<-c(i,j)
PHI[[cont]]<-phi_ij
}
}
}
#x<-1:n[M]
x1<-dx[M]
bs<-choose(n[M]-1,x1-1)*(1-csi[M])^(x1-1)*csi[M]^(n[M]-x1)
ps<-(ppi[M]*bs+(1-ppi[M])/n[M])
PSHIFT[[M]]<-bs
PCUB[[M]]<-ps
find<-find%x%ps

cub<-find*SAR
cas<-prod(n)
find<-fi*find+(1-fi)/cas
f<-cub*fi+(1-fi)/cas

list(find=find,f=f,cub=cub,D=D,L=L,PHI=PHI,SAR=SAR,PSHIFT=PSHIFT,PCUB=PCUB,CONT=CONT)
}
############################

############################
J_SCUB_so<-function(n,csi,p,W,dx,fi){

da<-SCUB_so(n,csi,p,W,dx,fi)
L<-da$L
D<-da$D
ps<-da$PSHIFT
pcub<-da$PCUB


M<-length(n)

Q<-list()
P<-list()
if(M>1){
for(k in 1:M){

QS<-0
left<-1
right<-1
if(k<M){
      for(j in (k+1):M){

right<-right%x%pcub[[j]]
#cont<-sum((M-1):(M-k+1))+(j-k)
cont<-sum(seq(M-1,by=-1,length=k-1))+(j-k)

Lkj<-L[[cont]]

QS<-QS+W[k,j]*Lkj
}}
if(k>1){
for(j in 1:(k-1)){

left<-left%x%pcub[[j]]
#cont<-sum((M-1):(M-k+1))+(j-k)
cont<-sum(seq(M-1,by=-1,length=j-1))+(k-j)
Dkj<-D[[cont]]
QS<-QS+W[j,k]*Dkj
}}
P[[k]]<-left%x%diag(1,n[k])[dx[k],]%x%right
Q[[k]]<-QS
}
}
ll<-list(scub=da,P=P,Q=Q)
}

Jacob_SCUB_so<-function(n,csi,ppi,W,dx,fi){

da<-J_SCUB_so(n,csi,ppi,W,dx,fi)
find<-da$scub$find
#tau<-da$scub$f
cub<-da$scub$cub
P<-da$P
Q<-da$Q

SAR<-da$scub$SAR
pshift<-da$scub$PSHIFT
#print(pshift)
PHI<-da$scub$PHI

p_pi<-pshift[[1]]-matrix(1,n[1])/n[1]

p_csi<-ppi[1]*pshift[[1]]* (   ( n[1]-csi[1]*(n[1]-1)-matrix(1:n[1])  )  /( csi[1]*(1-csi[1]) )   )

tau_mu<-cbind(p_csi,p_pi)
pi_alpha<-ppi*(  1-ppi  )

csi_beta<-csi*(1-csi)
if(nvar==1) tau_theta<-tau_mu%*%(csi_beta%s%pi_alpha)

if(nvar>1){
psi_csi<- -ppi[1]*exp(-1)*(1-exp(-1))*(n[1]-1)*((1-csi[1])*exp(-1)+csi[1])^(n[1]-2)*matrix(1,n[1])

psi_pi<--exp(-1)*((1-csi[1])*exp(-1)+csi[1])^(n[1]-1)*matrix(1,n[1])+exp(-1)*(1-exp(-n[1]))/n[1]/(1-exp(-1))*matrix(1,n[1])

tau_csi<-diag(c(SAR),1)%*%P[[1]]%*%p_csi+diag(c(find),1)%*%Q[[1]]%*%psi_csi
tau_pi<-diag(c(SAR),1)%*%P[[1]]%*%p_pi+diag(c(find),1)%*%Q[[1]]%*%psi_pi
M<-length(n)

for(i in 2:M){
p_csi<-ppi[i]*pshift[[i]]*(   ( n[i]-csi[i]*(n[i]-1)-matrix(1:n[i])) / (csi[i]*(1-csi[i]) )       )
#print(p_csi)
p_pi<-pshift[[i]]-matrix(1,n[i])/n[i]

psi_csi<- -ppi[i]*exp(-1)*(1-exp(-1))*(n[i]-1)*((1-csi[i])*exp(-1)+csi[i])^(n[i]-2)*matrix(1,n[i])


psi_pi<- -exp(-1)*((1-csi[i])*exp(-1)+csi[i])^(n[i]-1)*matrix(1,n[i])+exp(-1)*(1-exp(-n[i]))/n[i]/(1-exp(-1))*matrix(1,n[i])
#print(cbind(p_csi,p_pi,psi_csi,psi_pi))
tau_csi<-cbind(tau_csi,
diag(c(SAR),1)%*%P[[i]]%*%p_csi+diag(c(find),1)%*%Q[[i]]%*%psi_csi)
tau_pi<-cbind(tau_pi,diag(c(SAR),1)%*%P[[i]]%*%p_pi+diag(c(find),1)%*%Q[[i]]%*%psi_pi)
}
tau_w<-t(  matrix(find*simplify2array(PHI,higher=FALSE) ))%*%WMAT
tau_mu<-cbind(tau_csi,tau_pi,tau_w)*fi


pi_alpha<-diag(c(ppi))%*%(  diag(1,length(ppi))-diag(c(ppi))  )

csi_beta<-diag(c(csi))%*%(diag(1,length(csi))-diag(c(csi)) )

#print(cbind(ppi,csi))
#print(tau_csi)
#if(M==1) {tau_theta<-tau_mu%*%(csi_beta%s%pi_alpha)
#if(nat.par){tau_theta<-tau_mu%*%(csi_beta%s%diag(1,nvar)%s%diag(1,dim(WMAT)[2]))}}
       tau_fi<-(cub-1/prod(n))*fi*(1-fi)
        tau_theta<-tau_mu%*%(csi_beta%s%pi_alpha%s%diag(1,dim(WMAT)[2])) 
       if(nat.par){tau_theta<-tau_mu%*%(csi_beta%s%diag(1,nvar)%s%diag(1,dim(WMAT)[2]))}

        tau_theta<-cbind(tau_theta,tau_fi)
        


#print((csi_beta%s%pi_alpha%s%diag(1,dim(WMAT)[2])))
}

list(tau=da$scub$f,tau_theta=tau_theta)
}
#######################scores&fisher###################################################
#################
Gscub_so<-function(theta){


theta.pi<-theta[(sum(p)+1):(sum(p)+sum(p_U))]
theta.csi<-theta[1:sum(p)]
fi<-1
#ppi<-exp(theta.pi[1])/(1+exp(theta.pi[1]))
if(nvar>1){
  np<-length(theta)
  fi<-theta[np]
  fi<-exp(fi)/(1+exp(fi))
w<-theta[-( 1:(sum(p)+sum(p_U)) )]
w<-w[-length(w)]
w<-WMAT%*%w

W<-triang(w,(nvar-1))
#W<-rbind( cbind(W,rep(0,(nvar-1))),rep(0,nvar))
W<-cbind(rep(0,nvar), rbind(W,rep(0,(nvar-1))))

#for(i in 2:nvar){
#ppi<-c(ppi, exp(theta.pi[i])/(1+exp(theta.pi[i])))}
}
CSI<-matrix(0,dim(data)[1],nvar)
CSI_U<--matrix(0,dim(data)[1],nvar)
pstart=0
pstart_U<-0
for(i in 1:nvar){
e<-X[[i]]%*%theta.csi[(pstart+1):(pstart+p[i])]
e_U<-X_U[[i]]%*%theta.pi[(pstart_U+1):(pstart_U+p_U[i])]
CSI[,i]<-pmin(1-bind,pmax(bind,exp(e)/(1+exp(e))))
CSI_U[,i]<-pmin(1-bind,pmax(bind,exp(e_U)/(1+exp(e_U))))
#CSI[,i]<-exp(e)/(1+exp(e))
pstart<-pstart+p[i]
pstart_U<-pstart_U+p_U[i]}
GMmy<-function(dati){

y<-dati[1:nvar]
xx<-dati[(3*nvar+1): (3*nvar+sum(p)) ]
xx_U<-dati[(3*nvar+sum(p)+1):(3*nvar+sum(p)+sum(p_U) ) ]
csi<-dati[(nvar+1):(nvar+nvar)]
ppi<-dati[(nvar+nvar+1):(3*nvar)]
U<-matrix(0,0,0)
U_U<-matrix(0,0,0)
M<-length(n)


for(i in 1:M){U<-U%s%matrix(1,1,p[i])
U_U<-U_U%s%matrix(1,1,p_U[i])
}

DX<-U%*%diag(c(xx))
DX_U<-U_U%*%diag(c(xx_U))
J<-Jacob_SCUB_so(n,csi,ppi,W,y,fi)
JJ<-J$tau_theta
JJ[abs(JJ)>0]<-JJ[abs(JJ)>0]/max(0.00001,c(J$tau))

if(M>1){ JJ<-JJ%*%(DX%s%DX_U%s%diag(1,dim(WMAT)[2])%s%1)}
else { JJ<-JJ%*%(DX%s%DX_U)
JJ[y,]}

}
s<-apply(X=cbind(data[,1:nvar],CSI,CSI_U,XX,XX_U),MARGIN=1,FUN=GMmy)

s<-t(s)

}


################# MAIN PART ### MS.Cub #############################
if(compare){
return(comp<-compareDerivatives(f=Lmscub,grad=Gscub_so,t0=start,print=FALSE))}

if(numeric){


fit<-maxLik(
logLik=Lmscub,grad=NULL,hess=NULL,start=start,method=method,print.level=print.level,
iterlim=iterlim,tol=tol,finalHessian=finalHessian,fixed=fixed)
}
else{
ptm<-proc.time()
if(NMiter>0){
  fit<-maxLik(logLik=Lmscub,grad=Gscub_so,hess=NULL,start=start,method="NM",print.level=print.level,
              iterlim=NMiter,tol=tol,finalHessian=finalHessian,fixed=fixed)
  start<-fit$estimate
  print("NM starting values")
  print(start)}

  
fit<-maxLik(logLik=Lmscub,grad=Gscub_so,hess=NULL,start=start,method=method,print.level=print.level,
iterlim=iterlim,tol=tol,finalHessian=finalHessian,fixed=fixed)


print("elapsed time")
print(proc.time()-ptm)
list(fit=fit,formula=f,formula.unc=func,W=WMAT,start=start)
}

}

#############################################################################
#The following functions are  used for computing starting values and are a subset of
# a software by Domenico Piccolo with minor modifications to integrate it within
# MS2.Cub
#############################################################################
#     >>> CUB models INFERENCE  <<< Version 2.0               September 2009 
#############################################################################
#---------------------------------------------------------------------------
# (C) Copyright by Domenico Piccolo: domenico.piccolo@unina.it
#***************************************************************************
#** All Rights Reserved.        # (C) February 2005 - September 2009.
#***************************************************************************
#** This entire File Header must accompany all files using
#** any portion, in whole or in part, of this Source Code.
#** If you wish to distribute any portion of the proprietary Source
#** Code, you must first obtain written permission from the Author.
#**                                                                        
#** If you use this program or part of it for applied or research projects,
#** please inform the Author via E-mail to allow updating references file. 
#** When using this software, please correctly acknowledge it.
#**                                                                       
#** This program is freely released without any responsibility for Authors. 
############################################################################
#** 
#** ================================================================================
#** This software derives from original GAUSS code, implemented by D.Piccolo(2001-2007).
#** Shelter code has been implemented by M. Iannario...........March 2008-July 2009. 
#** ================================================================================gama
#  
#** ================================================================================
#  The main reference for a correct and updated program of this code is:
#                                                                                  
# > M.Iannario and D. Piccolo (2009), "A program in R for CUB models inference",
#                                    (version 2.0),available at: www.dipstat.unina.it



CUBpq<-function(ordinal,Y,W,numiter,toler){

 m=max(ordinal) 
                                        tt0=proc.time();
#cubpq<-function(ordinal,Y,W){
                                      
n=length(ordinal);
p=ncol(as.matrix(Y))-1;
q=ncol(as.matrix(W))-1;
aver=mean(ordinal);
#YY=cbind(rep(1,n),Y);       # add 1's first column to Y
#WW=cbind(rep(1,n),W);       # add 1's first column to W

       # add 1's first column to W
YY<-Y
WW<-W
#*************
#*  CUB(p,q) *
#*************
kkk<-function(m,ordinal){choose(m-1,ordinal-1)}
eibeta<-function(Y,bet){
ddim=dim(as.matrix(Y));
#YY=cbind(rep(1,ddim[1]),Y);
YY<-Y

1/(1+exp(-YY%*%bet))
}

inibestgama<-function(ordinal,W){
#WW=cbind(rep(1,length(ordinal)),W);     # add 1's first column to W}
  WW<-W
ni=log((m-ordinal+0.5)/(ordinal-0.5));
gama=(solve(t(WW)%*%WW))%*%(t(WW)%*%ni); 
return(gama);
}

figama<-function(W,gama){
ddim=dim(as.matrix(W));
#WW=cbind(rep(1,ddim[1]),W);  
# add 1's first column to W
WW<-W
1/(1+exp(-WW%*%gama))
}

bitgama<-function(ordinal,W,gama){
#WW=cbind(rep(1,length(ordinal)),W);     # add 1's first column to W}
  WW<-W
ci=exp(-WW%*%gama);
kkk(m,ordinal)*exp((ordinal-1)*log(ci)-(m-1)*log(1+ci));
}

probmub11<-function(m,ordinal,Y,W,bet,gama){
eibeta(Y,bet)*(bitgama(ordinal,W,gama)-1/m)+1/m;
}

loglikcubpq<-function(ordinal,Y,W,bet,gama){
probn=probmub11(m,ordinal,Y,W,bet,gama);
sum(log(probn));
}

#probmub01<-function(m,ordinal,W,pai,gama){
#pai*(bitgama(ordinal,W,gama)-1/m)+1/m;
#}

#loglikcub0q<-function(ordinal,W,pai,gama){
#probn=probmub01(m,ordinal,W,pai,gama);
#sum(log(probn));
#}



##################################################################
betjj=rep(0.1,p+1); gamajj=inibestgama(ordinal,W);  ### Attention !!!
#################################################################################
loglikjj=loglikcubpq(ordinal,Y,W,betjj,gamajj);
# ********************************************************************
# ************* E-M algorithm for CUB(p,q) ***************************
# ********************************************************************
nniter=1;
while(nniter<=numiter){
    loglikold=loglikjj;
    vettn=bitgama(ordinal,W,gamajj);   
aai=exp(-(YY%*%betjj));
ttau=1/(1+aai/(m*vettn));        # tau is a reserved word in R

################ effe1 is QPAI ####################################
effe1<-function(bet,esterno=cbind(ttau,YY)){
tauno=esterno[,1];
covar=as.matrix(esterno[,2:ncol(esterno)]);

sum(log(1+exp(-covar%*%bet))+(1-tauno)*(covar%*%bet));
}
################ effe2 is QCSI ####################################
effe2<-function(gama,esterno=cbind(ttau,ordinal,WW)){  
tauno=esterno[,1];
ordd=esterno[,2];
covar=esterno[,3:ncol(esterno)];
sum(ttau*((ordinal-1)*(WW%*%gama)+(m-1)*log(1+exp(-WW%*%gama))));
}
####################  maximize w.r.t. bet and gama    ############
        nlmaxbet=nlm(effe1,betjj);   
        nlmaxgama=nlm(effe2,gamajj);   
################################################################         

betjj=nlmaxbet$estimate;                #updated bet estimates
gamajj=nlmaxgama$estimate;              #updated gama estimates
loglikjj=loglikcubpq(ordinal,Y,W,betjj,gamajj);
# print(c(nniter,betjj,gamajj,loglikjj)); #OPTIONAL PRINTING OF ITERATIONS
     testll=abs(loglikjj-loglikold);
if(testll<=toler) break else {loglikold=loglikjj};
nniter=nniter+1;}
bet=betjj;  gama=gamajj;  loglik=loglikjj;

list(pai=bet,gama=gama)
}

####################################  second main function ########################################

MS2.CUB.UTIL<-function(cuscub,data,FISHER=FALSE,JOINTP=TRUE,
                       JACOBP=FALSE,bind=1e-04,nat.par=FALSE){
nat.par<-nat.par
theta<-cuscub$fit$estimate
f<-cuscub$formula
func<-cuscub$formula.unc
nvar<-length(f)

v<-rep(0,nvar)
p<-v
X<-list()
for(i in 1:nvar){
v[i]<-all.vars(f[[i]])[1]
X[[i]]<-model.matrix(f[[i]],data)
XX<-X[[i]]
p[i]<-dim(X[[i]])[2]
}
p_U<-rep(0,nvar)
X_U<-list()
for(i in 1:nvar){
#v_u[i]<-all.vars(func[[i]])[1]
X_U[[i]]<-model.matrix(func[[i]],data)
XX_U<-X_U[[i]]
p_U[i]<-dim(X_U[[i]])[2]
}

no<-setdiff(names(data),v)
data<-data[,c(v,no)]


n<-apply(as.matrix(data[,1:nvar]),2,max)

WMAT<-cuscub$W

################## auxiliar functions
P.scub<-function(theta){
theta.pi<-theta[(sum(p)+1):(sum(p)+sum(p_U))]
theta.csi<-theta[1:sum(p)]
fi<-1
if(nvar>1){
np<-length(theta)
theta.fi<-theta[np]
fi<-exp(theta.fi)/(1+exp(theta.fi))
w<-theta[-( 1:(sum(p)+sum(p_U)) )]
w<-w[-length(w)]
w<-WMAT%*%w
W<-triang(w,(nvar-1))
W<-cbind(rep(0,nvar), rbind(W,rep(0,(nvar-1))))
}

CSI<-matrix(0,dim(data)[1],nvar)
CSI_U<-matrix(0,dim(data)[1],nvar)
pstart<-0
pstart_U<-0

for(i in 1:nvar){
e<-X[[i]]%*%theta.csi[(pstart+1):(pstart+p[i])]
e_U<-X_U[[i]]%*%theta.pi[(pstart_U+1):(pstart_U+p_U[i])]
#CSI[,i]<-exp(e)/(1+exp(e))
CSI[,i]<-pmin(1-bind,pmax(bind,exp(e)/(1+exp(e))))
CSI_U[,i]<-pmin(1-bind,pmax(bind,exp(e_U)/(1+exp(e_U))))
pstart_U<-pstart_U+p_U[i]
pstart<-pstart+p[i]}

LMmy<-function(data){
csi<-data[1:nvar]
csi_U<-data[(nvar+1):(2*nvar)]
pp<-SCUB(n,csi,csi_U,W,fi)
p<-pp$fmix}
l<-apply(X=cbind(CSI,CSI_U),MARGIN=1,FUN=LMmy)
CVmy<-function(data){
  csi<-data[1:nvar]
  csi_U<-data[(nvar+1):(2*nvar)]
  pp<-SCUB(n,csi,csi_U,W,fi) 
Ma<--1/sapply(pp$PHI,min)
mi<--1/sapply(pp$PHI,max)
cv<-c(mi,Ma)}
cv<-apply(X=cbind(CSI,CSI_U),MARGIN=1,FUN=CVmy)
list(l=l,CV=cv)}

#########################################################################
SCUB<-function(n,csi,ppi,W,fi){
M<-nvar
#x<-1:n[M]
find<-1
L<-list()
D<-list()
PHI<-list()
CONT<-list()
PSHIFT<-list()
PCUB<-list()

SAR<-matrix(1,prod(n))
if(nvar>1){
cont<-0
for(i in 1:(M-1)){
pi1=ppi[i]
csi1<-csi[i]
x1<-1:n[i]
n1<-n[i]
bs<-choose(n1-1,x1-1)*(1-csi1)^(x1-1)*csi1^(n1-x1)
ps<-(pi1*bs+(1-pi1)/n1)
phi_i<-( exp(-x1) -pi1*exp(-1)*(   (1-csi1)* exp(-1)+csi1 )^(n1-1)-(1-pi1)/n1* (exp(-1)-exp(-n1-1))/(1-exp(-1)   ))
find<-find%x%ps
PSHIFT[[i]]<-bs
PCUB[[i]]<-ps
for( j in (i+1):M) {
cont<-cont+1
pi2=ppi[j]
csi2<-csi[j]
n2<-n[j]
x2<-1:n[j]
w<-W[i,j]
phi_j<-( exp(-x2)-pi2*exp(-1)*(   (1-csi2)* exp(-1)+csi2 )^(n2-1)-(1-pi2)/n2* (exp(-1)-exp(-n2-1))/(1-exp(-1)   ))
phi_ij<-f_mu(0,i,n)%x%phi_i%x%f_mu(i,j,n)%x%phi_j%x%f_mu(j,M+1,n)
f2<- w*phi_ij
SAR<-SAR+f2
D_ij<-f_mu(0,i,n)%x%phi_i%x%f_mu(i,j,n)%x%diag(1,n2)%x%f_mu(j,M+1,n)
L_ij<-f_mu(0,i,n)%x%diag(1,n1)%x%f_mu(i,j,n)%x%phi_j%x%f_mu(j,M+1,n)
D[[cont]]<-D_ij
L[[cont]]<-L_ij
CONT[[cont]]<-c(i,j)
PHI[[cont]]<-phi_ij
}
}
}
x<-1:n[M]
bs<-choose(n[M]-1,x-1)*(1-csi[M])^(x-1)*csi[M]^(n[M]-x)
ps<-(ppi[M]*bs+(1-ppi[M])/n[M])
PSHIFT[[M]]<-bs
PCUB[[M]]<-ps
find<-find%x%ps

f<-diag(c(find))%*%SAR
fmix=f*fi+(1-fi)/prod(n)
list(find=find,f=f,fmix=fmix,SAR=SAR,PSHIFT=PSHIFT,PCUB=PCUB,D=D,L=L,PHI=PHI,CONT=CONT)
}
############################
f_mu<-function(i,j,n){
if(j >(i+1)) {
d<-prod(n[(i+1):(j-1)])
mu<-matrix(1,d)}
else { mu=1}
}
############################

J_SCUB<-function(n,csi,p,W,fi){

da<-SCUB(n,csi,p,W,fi)
L<-da$L
D<-da$D
ps<-da$PSHIFT
pcub<-da$PCUB


M<-length(n)

Q<-list()
P<-list()
for(k in 1:M){

QS<-0
left<-1
right<-1
if(k<M){
      for(j in (k+1):M){

right<-right%x%pcub[[j]]
#cont<-sum((M-1):(M-k+1))+(j-k)
cont<-sum(seq(M-1,by=-1,length=k-1))+(j-k)

Lkj<-L[[cont]]

QS<-QS+W[k,j]*Lkj
}}
if(k>1){
for(j in 1:(k-1)){

left<-left%x%pcub[[j]]
#cont<-sum((M-1):(M-k+1))+(j-k)
cont<-sum(seq(M-1,by=-1,length=j-1))+(k-j)
Dkj<-D[[cont]]
QS<-QS+W[j,k]*Dkj
}}
P[[k]]<-left%x%diag(1,n[k])%x%right
Q[[k]]<-QS
}

ll<-list(scub=da,P=P,Q=Q)
}
#####################################################

Jacob_SCUB<-function(n,csi,ppi,W,fi){
da<-J_SCUB(n,csi,ppi,W,fi)
find<-da$scub$find
P<-da$P
Q<-da$Q

SAR<-da$scub$SAR
pshift<-da$scub$PSHIFT
PHI<-da$scub$PHI
p_pi<-pshift[[1]]-matrix(1,n[1])/n[1]

p_csi<-ppi[1]*diag(c(pshift[[1]]))%*%  (   ( n[1]-csi[1]*(n[1]-1)-matrix(1:n[1])  )  /( csi[1]*(1-csi[1]) )   )

if(nvar==1){
  pi_alpha<-ppi*(  1-ppi  )
  
  csi_beta<-csi*(1-csi)
  tau_theta<-tau_mu%*%(csi_beta%s%pi_alpha)
}
if(nvar>1){



psi_csi<- -ppi[1]*exp(-1)*(1-exp(-1))*(n[1]-1)*((1-csi[1])*exp(-1)+csi[1])^(n[1]-2)*matrix(1,n[1])

psi_pi<--exp(-1)*((1-csi[1])*exp(-1)+csi[1])^(n[1]-1)*matrix(1,n[1])+exp(-1)*(1-exp(-n[1]))/n[1]/(1-exp(-1))*matrix(1,n[1])

tau_csi<-diag(c(SAR))%*%P[[1]]%*%p_csi+diag(c(find))%*%Q[[1]]%*%psi_csi
tau_pi<-diag(c(SAR))%*%P[[1]]%*%p_pi+diag(c(find))%*%Q[[1]]%*%psi_pi
M<-nvar

for(i in 2:M){
p_csi<-ppi[i]*diag(c(pshift[[i]]))%*%(   ( n[i]-csi[i]*(n[i]-1)-matrix(1:n[i])) / (csi[i]*(1-csi[i]) )       )
p_pi<-pshift[[i]]-matrix(1,n[i])/n[i]

psi_csi<- -ppi[i]*exp(-1)*(1-exp(-1))*(n[i]-1)*((1-csi[i])*exp(-1)+csi[i])^(n[i]-2)*matrix(1,n[i])


psi_pi<- -exp(
-1)*((1-csi[i])*exp(-1)+csi[i])^(n[i]-1)*matrix(1,n[i])+exp(-1)*(1-exp(-n[i]))/n[i]/(1-exp(-1))*matrix(1,n[i])

tau_csi<-cbind(tau_csi,
diag(c(SAR))%*%P[[i]]%*%p_csi+diag(c(find))%*%Q[[i]]%*%psi_csi)
tau_pi<-cbind(tau_pi,diag(c(SAR))%*%P[[i]]%*%p_pi+diag(c(find))%*%Q[[i]]%*%psi_pi)
}
tau_w<-diag(c(find))%*%simplify2array(PHI,higher=FALSE)%*%WMAT
tau_mu<-cbind(tau_csi,tau_pi,tau_w)*fi


pi_alpha<-diag(c(ppi))%*%(  diag(1,length(ppi))-diag(c(ppi))  )

csi_beta<-diag(c(csi))%*%(diag(1,length(csi))-diag(c(csi)) )

tau_theta<-tau_mu%*%(csi_beta%s%pi_alpha%s%diag(1,dim(WMAT)[2]))
if(nat.par){tau_theta<-tau_mu%*%(csi_beta%s%diag(1,nvar)%s%diag(1,dim(WMAT)[2]))}
tau_fi<-(da$scub$fmix-1/prod(n))*fi*(1-fi)
tau_theta<-cbind(tau_theta,tau_fi)
}
list(tau=da$scub$fmix,tau_theta=tau_theta)
}
#######################scores&fisher###################################################

y.fun<-function(x,n){
i<-rev(cumprod(rev(n)))
i<-c(i[-1],1)
iy<-sum(i*(x-1))+1
#y<-matrix(0,1,prod(n))
#y[iy]<-1
}
############################Fisher
Fscub<-function(theta){
theta.pi<-theta[(sum(p)+1):(sum(p)+sum(p_U))]
theta.csi<-theta[1:sum(p)]
fi<-1
#ppi<-exp(theta.pi[1])/(1+exp(theta.pi[1]))
if(nvar>1){
np<-length(theta)
fi<-theta[np]
fi<-exp(fi)/(1+exp(fi))
w<-theta[-( 1:(sum(p)+sum(p_U)) )]
w<-w[-length(w)]
w<-WMAT%*%w

W<-triang(w,(nvar-1))
#W<-rbind( cbind(W,rep(0,(nvar-1))),rep(0,nvar))
W<-cbind(rep(0,nvar), rbind(W,rep(0,(nvar-1))))

#for(i in 2:nvar){
#ppi<-c(ppi, exp(theta.pi[i])/(1+exp(theta.pi[i])))}
}
CSI<-matrix(0,dim(data)[1],nvar)
CSI_U<--matrix(0,dim(data)[1],nvar)
pstart=0
pstart_U<-0
for(i in 1:nvar){
e<-X[[i]]%*%theta.csi[(pstart+1):(pstart+p[i])]
e_U<-X_U[[i]]%*%theta.pi[(pstart_U+1):(pstart_U+p_U[i])]
CSI[,i]<-pmin(1-bind,pmax(bind,exp(e)/(1+exp(e))))
CSI_U[,i]<-pmin(1-bind,pmax(bind,exp(e_U)/(1+exp(e_U))))
#CSI[,i]<-exp(e)/(1+exp(e))
pstart<-pstart+p[i]
pstart_U<-pstart_U+p_U[i]}

FMmy<-function(dati){
#y<-dati[1:nvar]
xx<-dati[(2*nvar+1): (2*nvar+sum(p)) ]
xx_U<-dati[(2*nvar+sum(p)+1):(2*nvar+sum(p)+sum(p_U) ) ]
csi<-dati[1:nvar]
ppi<-dati[(nvar+1):(2*nvar)]
U<-matrix(0,0,0)
U_U<-matrix(0,0,0)
M<-nvar



for(i in 1:M){U<-U%s%matrix(1,1,p[i])
U_U<-U_U%s%matrix(1,1,p_U[i])
}

DX<-U%*%diag(c(xx))
DX_U<-U_U%*%diag(c(xx_U))
###

if(nvar>1){
J<-Jacob_SCUB(n,csi,ppi,W,fi)
JJ<-J$tau_theta%*%( DX%s%DX_U%s%diag(1,dim(WMAT)[2])%s%1 )
ps<-J$tau
}

else{
#J<-Jacob_SCUB_so(n,csi,ppi,W,y)
x<-1:n[1]
bs<-choose(n[1]-1,x-1)*(1-csi)^(x-1)*csi^(n[1]-x)
ps<-(ppi*bs+(1-ppi)/n[1])
p_pi<-bs-matrix(1,n[1])/n[1]

p_csi<-ppi*bs* (   ( n[1]-csi*(n[1]-1)-matrix(1:n[1])  )  /( csi*(1-csi) )   )

tau_mu<-cbind(p_csi,p_pi)
pi_alpha<-ppi*(  1-ppi  )

csi_beta<-csi*(1-csi)
tau_theta<-tau_mu%*%(csi_beta%s%pi_alpha)
JJ<-tau_theta%*%(DX%s%DX_U)
#print(dim(JJ))
#print(dim(tau_theta))
}
JJ<--t(JJ)%*%diag(c(1/ps))%*%JJ
}

XX<-do.call(cbind,X)
XX_U<-do.call(cbind,X_U)
f<-rowSums(  apply(X=cbind(CSI,CSI_U,XX,XX_U),MARGIN=1,FUN=FMmy)  )
if(nvar>1) np<-sum(p_U)+sum(p)+dim(WMAT)[2]+1
else{  np<-sum(p)+sum(p_U)}
f<-matrix(f,np,np)

}
#FMAT<-NULL
#JP<-NULL
#if(FISHER) FMAT<--Fscub(theta)
#if(JOINTP) JP<-P.scub(theta)
#list(FISHER=FMAT,P=JP)
#}


#################derivatives#######

Dscub<-function(theta){
  theta.pi<-theta[(sum(p)+1):(sum(p)+sum(p_U))]
  theta.csi<-theta[1:sum(p)]
  fi<-1
  #ppi<-exp(theta.pi[1])/(1+exp(theta.pi[1]))
  if(nvar>1){
    np<-length(theta)
    fi<-theta[np]
    fi<-exp(fi)/(1+exp(fi))
    w<-theta[-( 1:(sum(p)+sum(p_U)) )]
    w<-w[-length(w)]
    w<-WMAT%*%w
    
    W<-triang(w,(nvar-1))
    #W<-rbind( cbind(W,rep(0,(nvar-1))),rep(0,nvar))
    W<-cbind(rep(0,nvar), rbind(W,rep(0,(nvar-1))))
    
    #for(i in 2:nvar){
    #ppi<-c(ppi, exp(theta.pi[i])/(1+exp(theta.pi[i])))}
  }
  CSI<-matrix(0,dim(data)[1],nvar)
  CSI_U<--matrix(0,dim(data)[1],nvar)
  pstart=0
  pstart_U<-0
  for(i in 1:nvar){
    e<-X[[i]]%*%theta.csi[(pstart+1):(pstart+p[i])]
    e_U<-X_U[[i]]%*%theta.pi[(pstart_U+1):(pstart_U+p_U[i])]
    CSI[,i]<-pmin(1-bind,pmax(bind,exp(e)/(1+exp(e))))
    CSI_U[,i]<-pmin(1-bind,pmax(bind,exp(e_U)/(1+exp(e_U))))
    #CSI[,i]<-exp(e)/(1+exp(e))
    pstart<-pstart+p[i]
    pstart_U<-pstart_U+p_U[i]}
  
  FMmy<-function(dati){
    #y<-dati[1:nvar]
    xx<-dati[(2*nvar+1): (2*nvar+sum(p)) ]
    xx_U<-dati[(2*nvar+sum(p)+1):(2*nvar+sum(p)+sum(p_U) ) ]
    csi<-dati[1:nvar]
    ppi<-dati[(nvar+1):(2*nvar)]
    U<-matrix(0,0,0)
    U_U<-matrix(0,0,0)
    M<-nvar
    
    
    
    for(i in 1:M){U<-U%s%matrix(1,1,p[i])
                  U_U<-U_U%s%matrix(1,1,p_U[i])
    }
    
    DX<-U%*%diag(c(xx))
    DX_U<-U_U%*%diag(c(xx_U))
    ###
    
    if(nvar>1){
      J<-Jacob_SCUB(n,csi,ppi,W,fi)
      JJ<-J$tau_theta%*%( DX%s%DX_U%s%diag(1,dim(WMAT)[2])%s%1 )
      ps<-J$tau
    }
    
    else{
      #J<-Jacob_SCUB_so(n,csi,ppi,W,y)
      x<-1:n[1]
      bs<-choose(n[1]-1,x-1)*(1-csi)^(x-1)*csi^(n[1]-x)
      ps<-(ppi*bs+(1-ppi)/n[1])
      p_pi<-bs-matrix(1,n[1])/n[1]
      
      p_csi<-ppi*bs* (   ( n[1]-csi*(n[1]-1)-matrix(1:n[1])  )  /( csi*(1-csi) )   )
      
      tau_mu<-cbind(p_csi,p_pi)
      pi_alpha<-ppi*(  1-ppi  )
      
      csi_beta<-csi*(1-csi)
      tau_theta<-tau_mu%*%(csi_beta%s%pi_alpha)
      JJ<-tau_theta%*%(DX%s%DX_U)
      #print(dim(JJ))
      #print(dim(tau_theta))
    }
    t(vec(JJ))
  }
  
  XX<-do.call(cbind,X)
  XX_U<-do.call(cbind,X_U)
  f<- rowSums(  apply(X=cbind(CSI,CSI_U,XX,XX_U),MARGIN=1,FUN=FMmy))  
  if(nvar>1) np<-sum(p_U)+sum(p)+dim(WMAT)[2]+1
  else{  np<-sum(p)+sum(p_U)}
  f<-matrix(f,prod(n),np)
  
}
FMAT<-NULL
JP<-NULL
JACOBPROB<-NULL
datact<-NULL
var.res=NULL
CV=NULL
if(JACOBP) JACOBPROB<-Dscub(theta)
if(FISHER) FMAT<--Fscub(theta)
if(JOINTP) { JP<-P.scub(theta)
 CV=JP$CV
 CVm<-apply(CV[1:(dim(CV)[1]/2),],1,max)
 CVM<-apply( CV[((dim(CV)[1]/2)+1):dim(CV)[1],] ,1,min)
 CV<-cbind(CVm,CVM)
 no<-names(theta)
 l<-length(no)
 no<-no[(l-nvar*(nvar-1)/2):(l-1)]
 rownames(CV)<-no
JP<-JP$l}       
if(JOINTP){
  if(!FISHER){FMAT<--cuscub$fit$hessian}
  nvar<-length(f)
  v<-rep(0,nvar)
  for(i in 1:nvar){
    v[i]<-all.vars(f[[i]])[1]
    
  }
  
  
   
  
  no<-setdiff(names(data),v)
  
  
  
  
  varn<-data[,v]
  #colnames(varn)<-no
  
  
  datact<-as.data.frame(table(varn))
  nr<-dim(datact)[2]
  #datact<-as.data.frame(apply(data,2 ,as.numeric))
  
  colnames(datact)<-c(v,"f")
  MJP<-matrix(rowSums(JP))/dim(data)[1]
  datact$f<-datact$f/dim(data)[1]
  datact$tau<-MJP
  datact$res<-datact$f-MJP
  if(!is.null(FMAT)&JACOBP){
  var.res<-rowSums(apply(JP,2,function(x) diag(c(x))-x%*%t(x)))/dim(data)[1]-
    (JACOBPROB/dim(data)[1])%*%solve(FMAT)%*%t(JACOBPROB/dim(data)[1])
datact$restd<-datact$res/sqrt(diag(var.res))
datact$SE<-sqrt(diag(var.res))}
datact$rePearson<-datact$res/sqrt(datact$tau)*sqrt(dim(data)[1])
stat<-summary(datact[,-(1:(nr-1))])
chi2<-sum(datact$rePearson^2)/(dim(datact)[1]) #chi2 diviso nobs

IP<-1-0.5*sum(abs(datact$res)) #indice iannaro piccolo
}
list(MATRICES=list(FISHER=FMAT,P=JP,DP=JACOBPROB,VRES=var.res),RES=datact,CV=CV,
     STAT=list(SUMMARY.P=stat,PHI=sqrt(chi2),
   IP=IP))
}







